
import * as $calcit from "./calcit.core.mjs";
import * as $app_DOT_config from "./app.config.mjs";
import * as $app_DOT_schema from "./app.schema.mjs";
import chalk from "chalk";
import { clear_twig_caches_$x_ } from "./recollect.twig.mjs";
import { create_process_$x_ } from "./app.manager.mjs";
import { diff_twig } from "./recollect.diff.mjs";
import { fileURLToPath } from "node:url";
import * as $fs from "node:fs";
import { kill_process_$x_ } from "./app.manager.mjs";
import latest_version from "latest-version";
import { merge_local_edn_$x_ } from "./cumulo-util.file.mjs";
import { nanoid } from "nanoid";
import * as $path from "node:path";
import { reel_reducer } from "./cumulo-reel.core.mjs";
import { reel_schema } from "./cumulo-reel.core.mjs";
import { refresh_reel } from "./cumulo-reel.core.mjs";
import { twig_container } from "./app.twig.container.mjs";
import { updater } from "./app.updater.mjs";
import url_parse from "url-parse";
import { write_mildly_$x_ } from "./cumulo-util.file.mjs";
import { wss_each_$x_ } from "./ws-edn.server.mjs";
import { wss_send_$x_ } from "./ws-edn.server.mjs";
import { wss_serve_$x_ } from "./ws-edn.server.mjs";
var _tag={};
["alive?","base","data","db","effect/kill","effect/persist","effect/run","id","key","kind","on-close","on-data","on-error","on-open","patch","port","processes","records","session/connect","session/disconnect","sessions","storage-file",].forEach(x => {
  _tag[x] = $calcit.newTag(x);
});


let _calcit_args_mismatch = (name, expected, got) => {
  return new Error(`\`${name}\` expected ${expected} params, got ${got}`);
};

export function persist_db_$x_() { 
if (arguments.length !== 0) throw _calcit_args_mismatch('persist-db!', 0, arguments.length);
let file_content = $calcit.format_cirru_edn($calcit.update($calcit.assoc($calcit.get($calcit.deref(_$s_reel), _tag["db"]), _tag["sessions"], $calcit._$n__$M_()), _tag["processes"], function f_PCT_(processes) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit.map_kv(processes, function f_PCT_(k, v) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
return $calcit._$L_(k, $calcit.assoc(v, _tag["alive?"], false))
}
)
}
));
return write_mildly_$x_(storage_file, file_content)

}
export function dispatch_$x_(op, sid) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('dispatch!', 2, arguments.length);
let op_id = nanoid();
let op_time = Date.now();
( $app_DOT_config.dev_$q_ ? console.log($calcit.printable("Dispatch!", $calcit.str(op), sid)) : null );
try {
  ( $calcit.not($calcit.tuple_$q_(op)) ? (function __fn__(){
let err_AUTO_1 = new Error($calcit.str("tag-match expected tuple, got", op));
 err_AUTO_1.data = null;
 throw err_AUTO_1;
})() : null );
let tag__1 = $calcit._$n_tuple_$o_nth(op, 0);

if ($calcit._$n__$e_(tag__1, _tag["effect/persist"])) { return persist_db_$x_()
 }
 else if ($calcit._$n__$e_(tag__1, _tag["effect/run"])) { let d = $calcit._$n_tuple_$o_nth(op, 1);
return create_process_$x_(d, dispatch_$x_, sid)
 }
 else if ($calcit._$n__$e_(tag__1, _tag["effect/kill"])) { let d = $calcit._$n_tuple_$o_nth(op, 1);
return kill_process_$x_(d, dispatch_$x_, sid)
 } else { return $calcit.reset_$x_(_$s_reel, reel_reducer($calcit.deref(_$s_reel), updater, op, sid, op_id, op_time)) }


} catch (errMsg_AUTO_2) {
  return  (function f_PCT_(error) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return console.error(error)
}
)(errMsg_AUTO_2)
}

}
export function check_version_$x_() { 
if (arguments.length !== 0) throw _calcit_args_mismatch('check-version!', 0, arguments.length);
let pkg = JSON.parse($fs.readFileSync($path.join(fileURLToPath(new URL(".", import.meta.url)), "../package.json")));
let version = pkg.version;
return latest_version(pkg.name).then(function f_PCT_(npm_version) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);

if ($calcit._$e_(npm_version, version)) { console.log($calcit.printable("Running latest version", version)) } else { console.log($calcit.printable(chalk.yellow($calcit.str("New version ", npm_version, " available, current one is ", version, " . Please upgrade!\n\nyarn global add termina\n")))) }
}
)

}
export function on_exit_$x_(code, _) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('on-exit!', 2, arguments.length);
persist_db_$x_();
return process.exit()
}
export function sync_clients_$x_(reel) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('sync-clients!', 1, arguments.length);
return wss_each_$x_(function f_PCT_(sid, socket) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
let db = $calcit.get(reel, _tag["db"]);
let records = $calcit.get(reel, _tag["records"]);
let session = $calcit.get_in(db, $calcit._$L_(_tag["sessions"], sid));
let old_store = (function __fn__(){
let v1__2 = $calcit.get($calcit.deref(_$s_client_caches), sid);

if ($calcit.nil_$q_(v1__2)) { return null }
 else if ($calcit._$e_(false, v1__2)) { return null } else { return v1__2 }

})();
let new_store = twig_container(db, session, records);
let changes = diff_twig(old_store, new_store, $calcit._$n__$M_(_tag["key"], _tag["id"]));
( $app_DOT_config.dev_$q_ ? console.log($calcit.printable("Changes for", sid, ":", changes, $calcit.count(records))) : null );

if ($calcit.not_$e_(changes, $calcit._$L_())) { wss_send_$x_(sid, $calcit._$n__$M_(_tag["kind"], _tag["patch"], _tag["data"], changes));
return $calcit.reset_$x_(_$s_client_caches, $calcit.assoc($calcit._$n_atom_$o_deref(_$s_client_caches), sid, new_store))
 } else { return  null; }

}
)
}
export function render_loop_$x_(_$s_loop) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('render-loop!', 1, arguments.length);
( $calcit.not($calcit.identical_$q_($calcit.deref(_$s_reader_reel), $calcit.deref(_$s_reel))) ? (function __fn__(){
$calcit.reset_$x_(_$s_reader_reel, $calcit.deref(_$s_reel));
return sync_clients_$x_($calcit.deref(_$s_reader_reel))

})() : null );
return $calcit.reset_$x_(_$s_loop, setTimeout(function f_PCT_() { 
if (arguments.length !== 0) throw _calcit_args_mismatch('f%', 0, arguments.length);
return render_loop_$x_(_$s_loop)
}
, 200))
}
export function run_server_$x_(port) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('run-server!', 1, arguments.length);
return wss_serve_$x_(port, $calcit._$n__$M_(_tag["on-open"], function f_PCT_(sid, socket) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
$calcit.deref(_$s_proxied_dispatch_$x_)($calcit._$o__$o_(_tag["session/connect"]), sid);
console.log($calcit.printable("New client."))
}
, _tag["on-data"], function f_PCT_(sid, action) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
return $calcit.deref(_$s_proxied_dispatch_$x_)(action, sid)
}
, _tag["on-close"], function f_PCT_(sid, event) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
console.log($calcit.printable("Client closed!"));
return $calcit.deref(_$s_proxied_dispatch_$x_)($calcit._$o__$o_(_tag["session/disconnect"]), sid)
}
, _tag["on-error"], function f_PCT_(error) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return console.error(error)
}
))
}
export function main_$x_() { 
if (arguments.length !== 0) throw _calcit_args_mismatch('main!', 0, arguments.length);
console.log($calcit.printable("Running mode:", ( $app_DOT_config.dev_$q_ ? "dev" : "release" )));
(function __fn__(){
let user_port = ( $calcit.some_$q_(process.env.port) ? parseInt(process.env.port) : null );
let port = (function __fn__(){

if ($calcit.nil_$q_(user_port)) { return $calcit.get($app_DOT_config.site, _tag["port"]) }
 else if ($calcit._$e_(false, user_port)) { return $calcit.get($app_DOT_config.site, _tag["port"]) } else { return user_port }
})();
let ui_url = url_parse("http://termina.mvc-works.org/", true);
run_server_$x_(port);
ui_url.query.port = port;
console.log($calcit.printable("Server started. Open UI on ", chalk.blue(ui_url.toString())))

})();
render_loop_$x_(_$s_loop_trigger);
process.on("SIGINT", on_exit_$x_);
setInterval(function _PCT__BSL_(_PCT_, _PCT_2) { 
if (arguments.length < 0) throw new Error('too few arguments');
if (arguments.length > 2) throw new Error('too many arguments');
return persist_db_$x_()
}
, 600);
return check_version_$x_()
}
export function reload_$x_() { 
if (arguments.length !== 0) throw _calcit_args_mismatch('reload!', 0, arguments.length);
console.log($calcit.printable("Code updated."));
clear_twig_caches_$x_();
$calcit.reset_$x_(_$s_proxied_dispatch_$x_, dispatch_$x_);
$calcit.reset_$x_(_$s_reel, refresh_reel($calcit.deref(_$s_reel), $calcit.deref(_$s_initial_db), updater));
clearTimeout($calcit.deref(_$s_loop_trigger));
render_loop_$x_(_$s_loop_trigger);
return sync_clients_$x_($calcit.deref(_$s_reader_reel))
}



export var _$s_client_caches = 
($calcit.peekDefatom("app.server/*client-caches") ?? $calcit.defatom("app.server/*client-caches", $calcit._$n__$M_()))
;

export var storage_file = $path.join(process.env.HOME, ".config", $calcit.get($app_DOT_config.site, _tag["storage-file"]));

export var _$s_initial_db = 
($calcit.peekDefatom("app.server/*initial-db") ?? $calcit.defatom("app.server/*initial-db", merge_local_edn_$x_($app_DOT_schema.database, storage_file, function f_PCT_(found_$q_) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);

if (found_$q_) { console.log($calcit.printable("Found local EDN data")) } else { console.log($calcit.printable("Found no data")) }
}
)))
;

export var _$s_loop_trigger = 
($calcit.peekDefatom("app.server/*loop-trigger") ?? $calcit.defatom("app.server/*loop-trigger", 0))
;

export var _$s_reel = 
($calcit.peekDefatom("app.server/*reel") ?? $calcit.defatom("app.server/*reel", $calcit.merge(reel_schema, $calcit._$n__$M_(_tag["base"], $calcit.deref(_$s_initial_db), _tag["db"], $calcit.deref(_$s_initial_db)))))
;

export var _$s_proxied_dispatch_$x_ = 
($calcit.peekDefatom("app.server/*proxied-dispatch!") ?? $calcit.defatom("app.server/*proxied-dispatch!", dispatch_$x_))
;

export var _$s_reader_reel = 
($calcit.peekDefatom("app.server/*reader-reel") ?? $calcit.defatom("app.server/*reader-reel", $calcit.deref(_$s_reel)))
;

