
import * as $calcit from "./calcit.core.mjs";
import * as $app_DOT_schema from "./app.schema.mjs";
var _tag={};
["alive?","command","content","cwd","data","error","histories","id","pid","processes","started-at","stderr","stdout","title","type",].forEach(x => {
  _tag[x] = $calcit.newTag(x);
});


let _calcit_args_mismatch = (name, expected, got) => {
  return new Error(`\`${name}\` expected ${expected} params, got ${got}`);
};

export function clear(db, op_data, sid, op_id, op_time) { 
if (arguments.length !== 5) throw _calcit_args_mismatch('clear', 5, arguments.length);
return $calcit.update(db, _tag["processes"], function f_PCT_(processes) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit.filter(processes, function f_PCT_(pair) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit.get($calcit.last(pair), _tag["alive?"])
}
)
}
)
}
export function clear_history(db, op_data, sid, op_id, op_time) { 
if (arguments.length !== 5) throw _calcit_args_mismatch('clear-history', 5, arguments.length);
return $calcit.assoc(db, _tag["histories"], $calcit._$L_())
}
export function create(db, op_data, sid, op_id, op_time) { 
if (arguments.length !== 5) throw _calcit_args_mismatch('create', 5, arguments.length);
let new_history = $calcit.merge($app_DOT_schema.history, $calcit._$n__$M_(_tag["command"], $calcit.get(op_data, _tag["command"]), _tag["cwd"], $calcit.get(op_data, _tag["cwd"]), _tag["started-at"], op_time, _tag["id"], op_id, _tag["title"], $calcit.get(op_data, _tag["title"])));
return $calcit.update($calcit.assoc_in(db, $calcit._$L_(_tag["processes"], $calcit.get(op_data, _tag["pid"])), $calcit.merge($app_DOT_schema.process, op_data, $calcit._$n__$M_(_tag["started-at"], op_time, _tag["alive?"], true))), _tag["histories"], function f_PCT_(histories) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);

if ($calcit.list_$q_(histories)) { return $calcit.conj(histories, new_history) } else { return $calcit._$L_(new_history) }
}
)

}
export function error(db, op_data, sid, op_id, op_time) { 
if (arguments.length !== 5) throw _calcit_args_mismatch('error', 5, arguments.length);
let pid = $calcit._$n_list_$o_nth(op_data, 0);
let data = $calcit._$n_list_$o_nth(op_data, 1);
return $calcit.update_in(db, $calcit._$L_(_tag["processes"], pid, _tag["content"]), function f_PCT_(content) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit.conj(content, $calcit._$n__$M_(_tag["type"], _tag["error"], _tag["data"], data))
}
)

}
export function finish(db, op_data, sid, op_id, op_time) { 
if (arguments.length !== 5) throw _calcit_args_mismatch('finish', 5, arguments.length);
return $calcit.assoc_in(db, $calcit._$L_(_tag["processes"], op_data, _tag["alive?"]), false)
}
export function remove_dead(db, op_data, sid, op_id, op_time) { 
if (arguments.length !== 5) throw _calcit_args_mismatch('remove-dead', 5, arguments.length);

if ($calcit._$e_(false, $calcit.get_in(db, $calcit._$L_(_tag["processes"], op_data, _tag["alive?"])))) { return $calcit.dissoc_in(db, $calcit._$L_(_tag["processes"], op_data)) } else { return db }
}
export function shorten_content(db, op_data, sid, op_id, op_time) { 
if (arguments.length !== 5) throw _calcit_args_mismatch('shorten-content', 5, arguments.length);
return $calcit.update_in(db, $calcit._$L_(_tag["processes"], op_data), function f_PCT_(process) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit.assoc(process, _tag["content"], $calcit._$L_())
}
)
}
export function stderr(db, op_data, sid, op_id, op_time) { 
if (arguments.length !== 5) throw _calcit_args_mismatch('stderr', 5, arguments.length);
let pid = $calcit._$n_list_$o_nth(op_data, 0);
let data = $calcit._$n_list_$o_nth(op_data, 1);
return $calcit.update_in(db, $calcit._$L_(_tag["processes"], pid, _tag["content"]), function f_PCT_(content) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit.conj(content, $calcit._$n__$M_(_tag["type"], _tag["stderr"], _tag["data"], data))
}
)

}
export function stdout(db, op_data, sid, op_id, op_time) { 
if (arguments.length !== 5) throw _calcit_args_mismatch('stdout', 5, arguments.length);
let pid = $calcit._$n_list_$o_nth(op_data, 0);
let data = $calcit._$n_list_$o_nth(op_data, 1);
return $calcit.update_in(db, $calcit._$L_(_tag["processes"], pid, _tag["content"]), function f_PCT_(content) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit.conj(content, $calcit._$n__$M_(_tag["type"], _tag["stdout"], _tag["data"], data))
}
)

}



