
import * as $calcit from "./calcit.core.mjs";
import { literal_$q_ } from "./recollect.util.mjs";
var _tag={};
["assoc","id","key","map-splice","pick","pick-in","replace","set-splice","update","update-in","vec-append","vec-drop",].forEach(x => {
  _tag[x] = $calcit.newTag(x);
});


let _calcit_args_mismatch = (name, expected, got) => {
  return new Error(`\`${name}\` expected ${expected} params, got ${got}`);
};

export function by_key(x, y) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('by-key', 2, arguments.length);
return $calcit._$n_compare($calcit.first(x), $calcit.first(y))
}
export function diff_set(collect_$x_, a, b) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('diff-set', 3, arguments.length);
let added = $calcit.difference(b, a);
let removed = $calcit.difference(a, b);
return collect_$x_($calcit._$o__$o_(_tag["set-splice"], removed, added))

}
export function fold_update(k, c0) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('fold-update', 2, arguments.length);
( $calcit.not($calcit.tuple_$q_(c0)) ? (function __fn__(){
let err_AUTO_1 = new Error($calcit.str("tag-match expected tuple, got", c0));
 err_AUTO_1.data = null;
 throw err_AUTO_1;
})() : null );
let tag__3 = $calcit._$n_tuple_$o_nth(c0, 0);

if ($calcit._$n__$e_(tag__3, _tag["update"])) { let k1 = $calcit._$n_tuple_$o_nth(c0, 1);
let c1 = $calcit._$n_tuple_$o_nth(c0, 2);
return $calcit._$o__$o_(_tag["update-in"], $calcit._$L_(k, k1), c1)
 }
 else if ($calcit._$n__$e_(tag__3, _tag["update-in"])) { let ks = $calcit._$n_tuple_$o_nth(c0, 1);
let c2 = $calcit._$n_tuple_$o_nth(c0, 2);
return $calcit._$o__$o_(_tag["update-in"], $calcit.prepend(ks, k), c2)
 }
 else if ($calcit._$n__$e_(tag__3, _tag["pick"])) { let k1 = $calcit._$n_tuple_$o_nth(c0, 1);
let cs = $calcit._$n_tuple_$o_nth(c0, 2);
return $calcit._$o__$o_(_tag["pick-in"], $calcit._$L_(k, k1), cs)
 }
 else if ($calcit._$n__$e_(tag__3, _tag["pick-in"])) { let ks = $calcit._$n_tuple_$o_nth(c0, 1);
let cs = $calcit._$n_tuple_$o_nth(c0, 2);
return $calcit._$o__$o_(_tag["pick-in"], $calcit.prepend(ks, k), cs)
 } else { return $calcit._$o__$o_(_tag["update"], k, c0) }


}
export function wrap_pick(collect_$x_, k, callback) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('wrap-pick', 3, arguments.length);
let _$s_chunk = $calcit.atom($calcit._$L_());
let collect_children_$x_ = function f_PCT_(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit.reset_$x_(_$s_chunk, $calcit.conj($calcit._$n_atom_$o_deref(_$s_chunk), x))
}
;
callback(collect_children_$x_);
let chunk = $calcit.deref(_$s_chunk);
let size = $calcit.count(chunk);

if ($calcit._GT_(size, 0)) { 
if ($calcit._$e_(size, 1)) { let c0 = $calcit.nth(chunk, 0);
( $calcit.not($calcit.tuple_$q_(c0)) ? (function __fn__(){
let err_AUTO_2 = new Error($calcit.str("tag-match expected tuple, got", c0));
 err_AUTO_2.data = null;
 throw err_AUTO_2;
})() : null );
let tag__2 = $calcit._$n_tuple_$o_nth(c0, 0);

if ($calcit._$n__$e_(tag__2, _tag["replace"])) { let v = $calcit._$n_tuple_$o_nth(c0, 1);
return collect_$x_($calcit._$o__$o_(_tag["assoc"], k, v))
 }
 else if ($calcit._$n__$e_(tag__2, _tag["assoc"])) { let k1 = $calcit._$n_tuple_$o_nth(c0, 1);
let v = $calcit._$n_tuple_$o_nth(c0, 2);
return collect_$x_($calcit._$o__$o_(_tag["update"], k, c0))
 } else { return collect_$x_(fold_update(k, c0)) }


 } else { return collect_$x_($calcit._$o__$o_(_tag["pick"], k, chunk)) } } else { return  null; }


}
export let find_vector_changes = function find_vector_changes(collect_$x_, idx, a_items, b_items, options) {
  
if (arguments.length !== 5) throw _calcit_args_mismatch('find-vector-changes', 5, arguments.length);
  
  let times_AUTO_5 = 0;
  while(true) { /* Tail Recursion */
    let ret_AUTO_4 = null;
    if (times_AUTO_5 > 10000000) throw new Error('tail recursion not finished after 10M iterations');
    
if (( $calcit.empty_$q_(a_items) ? (function __fn__(){
let v1__6 = $calcit.empty_$q_(b_items);

if (v1__6) { return v1__6 } else { return false }

})() : false )) { ret_AUTO_4 =null }
 else if ($calcit.empty_$q_(b_items)) { ret_AUTO_4 =collect_$x_($calcit._$o__$o_(_tag["vec-drop"], idx)) }
 else if ($calcit.empty_$q_(a_items)) { ret_AUTO_4 =collect_$x_($calcit._$o__$o_(_tag["vec-append"], b_items)) } else { wrap_pick(collect_$x_, idx, function f_PCT_(collect_children_$x_) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return diff_twig_iterate(collect_children_$x_, $calcit.first(a_items), $calcit.first(b_items), options)
}
);
ret_AUTO_4 =$calcit.recur(collect_$x_, $calcit.inc(idx), $calcit.rest(a_items), $calcit.rest(b_items), options)
 }

    if (ret_AUTO_4 instanceof $calcit.CalcitRecur) {
      
if (ret_AUTO_4.args.length !== 5) throw _calcit_args_mismatch('find-vector-changes', 5, ret_AUTO_4.args.length);
      [ collect_$x_, idx, a_items, b_items, options ] = ret_AUTO_4.args;
      
      times_AUTO_5 += 1;
      continue;
    } else {
      return ret_AUTO_4;
    }
  }
}

export function diff_twig_iterate(collect_$x_, a, b, options) { 
if (arguments.length !== 4) throw _calcit_args_mismatch('diff-twig-iterate', 4, arguments.length);

if ($calcit.identical_$q_(a, b)) { return null }
 else if ($calcit.not_$e_($calcit.type_of(a), $calcit.type_of(b))) { return collect_$x_($calcit._$o__$o_(_tag["replace"], b)) }
 else if (literal_$q_(b)) { return collect_$x_($calcit._$o__$o_(_tag["replace"], b)) }
 else if ($calcit.symbol_$q_(b)) { return collect_$x_($calcit._$o__$o_(_tag["replace"], b)) }
 else if ($calcit.set_$q_(b)) { return diff_set(collect_$x_, a, b) }
 else if ($calcit.tuple_$q_(b)) { return diff_tuple(collect_$x_, a, b, options) }
 else if ($calcit.map_$q_(b)) { return diff_map(collect_$x_, a, b, options) }
 else if ($calcit.list_$q_(b)) { return find_vector_changes(collect_$x_, 0, a, b, options) }
 else if ($calcit.record_$q_(b)) { return diff_record(collect_$x_, a, b, options) }
 else if ($calcit.ref_$q_(b)) { console.error($calcit.printable("[Error] unexpected ref to compare")) } else { console.error($calcit.printable("[Warning] unexpected data:", a, b))
 }
}
export function diff_tuple(collect_$x_, a, b, options) { 
if (arguments.length !== 4) throw _calcit_args_mismatch('diff-tuple', 4, arguments.length);

if ((function __fn__(){
let v1__1 = $calcit.not_$e_($calcit.nth(a, 0), $calcit.nth(b, 0));

if ($calcit.nil_$q_(v1__1)) { return $calcit.not_$e_($calcit._$n_tuple_$o_count(a), $calcit._$n_tuple_$o_count(b)) }
 else if ($calcit._$e_(false, v1__1)) { return $calcit.not_$e_($calcit._$n_tuple_$o_count(a), $calcit._$n_tuple_$o_count(b)) } else { return v1__1 }

})()) { return collect_$x_($calcit._$o__$o_(_tag["replace"], b)) } else { let rr = $calcit.range($calcit.dec($calcit._$n_tuple_$o_count(a)));
return $calcit.foldl(rr, null, function doseq_fn_PCT_(_acc, idx) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('doseq-fn%', 2, arguments.length);
let i = $calcit.inc(idx);
return wrap_pick(collect_$x_, i, function f_PCT_(collect_children_$x_) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return diff_twig_iterate(collect_children_$x_, $calcit.nth(a, i), $calcit.nth(b, i), options)
}
)

}
)
 }
}
export function diff_record(collect_$x_, a, b, options) { 
if (arguments.length !== 4) throw _calcit_args_mismatch('diff-record', 4, arguments.length);

if ($calcit.identical_$q_(a, b)) { return null }
 else if ($calcit._$n_record_$o_matches_$q_(a, b)) { let a_pairs = $calcit.to_pairs(a);
return $calcit.foldl(a_pairs, null, function doseq_fn_PCT_(_acc, pair) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('doseq-fn%', 2, arguments.length);
let k = $calcit._$n_list_$o_nth(pair, 0);
let va = $calcit._$n_list_$o_nth(pair, 1);
return wrap_pick(collect_$x_, k, function f_PCT_(collect_children_$x_) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return diff_twig_iterate(collect_children_$x_, va, $calcit._$n_record_$o_get(b, k), options)
}
)

}
)
 } else { return collect_$x_($calcit._$o__$o_(_tag["replace"], b)) }
}
export function diff_map(collect_$x_, a, b, options) { 
if (arguments.length !== 4) throw _calcit_args_mismatch('diff-map', 4, arguments.length);
let id_k = ( $calcit.nil_$q_(options) ? _tag["id"] : $calcit._$n_map_$o_get(options, _tag["key"]) );
let ka = $calcit._$n_map_$o_get(a, id_k);
let kb = $calcit._$n_map_$o_get(b, id_k);

if (( $calcit.some_$q_(ka) ? (function __fn__(){
let v1__4 = $calcit.not_$e_(ka, kb);

if (v1__4) { return v1__4 } else { return false }

})() : false )) { return collect_$x_($calcit._$o__$o_(_tag["replace"], b)) } else { let new_diff = $calcit._$n_map_$o_diff_new(b, a);
let drop_keys = $calcit._$n_map_$o_diff_keys(a, b);
let common_keys = $calcit._$n_map_$o_common_keys(a, b);
let a_pairs = $calcit.sort($calcit._$n_map_$o_to_list(a), by_key);
let b_pairs = $calcit.sort($calcit._$n_map_$o_to_list(b), by_key);
( $calcit.not(( $calcit._$n_set_$o_empty_$q_(drop_keys) ? (function __fn__(){
let v1__5 = $calcit._$n_map_$o_empty_$q_(new_diff);

if (v1__5) { return v1__5 } else { return false }

})() : false )) ? collect_$x_($calcit._$o__$o_(_tag["map-splice"], drop_keys, new_diff)) : null );
return $calcit.foldl(common_keys, null, function doseq_fn_PCT_(_acc, common_k) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('doseq-fn%', 2, arguments.length);
let va = $calcit._$n_map_$o_get(a, common_k);
let vb = $calcit._$n_map_$o_get(b, common_k);
return wrap_pick(collect_$x_, common_k, function f_PCT_(collect_children_$x_) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);

if ($calcit.not_$e_(va, vb)) { return diff_twig_iterate(collect_children_$x_, va, vb, options) } else { return  null; }
}
)

}
)
 }

}
export function diff_twig(a, b, options) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('diff-twig', 3, arguments.length);

if ($calcit.identical_$q_(a, b)) { return $calcit._$L_() } else { let _$s_changes = $calcit.atom($calcit._$L_());
let collect_$x_ = function f_PCT_(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit.reset_$x_(_$s_changes, $calcit.conj($calcit._$n_atom_$o_deref(_$s_changes), x))
}
;
diff_twig_iterate(collect_$x_, a, b, options);
return $calcit.deref(_$s_changes)
 }
}



