
import * as $calcit from "./calcit.core.mjs";
import { WebSocketServer } from "ws";
import * as $fs from "fs";
import * as $https from "https";
import { nanoid } from "nanoid";
var _tag={};
["cert","key","on-close","on-data","on-error","on-listening","on-open","path","port","server",].forEach(x => {
  _tag[x] = $calcit.newTag(x);
});


let _calcit_args_mismatch = (name, expected, got) => {
  return new Error(`\`${name}\` expected ${expected} params, got ${got}`);
};

export function maintain_socket_$x_(socket, options) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('maintain-socket!', 2, arguments.length);
let sid = nanoid();
$calcit.reset_$x_(_$s_global_connections, $calcit.assoc($calcit._$n_atom_$o_deref(_$s_global_connections), sid, socket));
(function __fn__(){
let on_open = $calcit.get(options, _tag["on-open"]);

if ($calcit.some_$q_(on_open)) { return on_open(sid, socket)
 } else { return  null; }

})();
$calcit.reset_$x_(_$s_proxied_data_listener, $calcit.get(options, _tag["on-data"]));
socket.on("message", function f_PCT_(raw_data, binary_$q_) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
let on_data = $calcit.deref(_$s_proxied_data_listener);

if ($calcit.some_$q_(on_data)) { return on_data(sid, $calcit.parse_cirru_edn(raw_data.toString()))
 } else { return  null; }

}
);
socket.on("close", function f_PCT_(event, binary_$q_) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
$calcit.reset_$x_(_$s_global_connections, $calcit.dissoc($calcit._$n_atom_$o_deref(_$s_global_connections), sid));
let on_close = $calcit.get(options, _tag["on-close"]);

if ($calcit.some_$q_(on_close)) { return on_close(sid, event)
 } else { return  null; }

}
);
return socket.on("error", function f_PCT_(error) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
$calcit.reset_$x_(_$s_global_connections, $calcit.dissoc($calcit._$n_atom_$o_deref(_$s_global_connections), sid));
let on_error = $calcit.get(options, _tag["on-error"]);

if ($calcit.some_$q_(on_error)) { return on_error(error) } else { return console.error(error) }

}
)

}
export function wss_each_$x_(handler) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('wss-each!', 1, arguments.length);
return $calcit.foldl($calcit.invoke_method("to-list",$calcit.deref(_$s_global_connections),), null, function doseq_fn_PCT_(_acc, pair) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('doseq-fn%', 2, arguments.length);
let sid = $calcit._$n_list_$o_nth(pair, 0);
let socket = $calcit._$n_list_$o_nth(pair, 1);
return handler(sid, socket)

}
)
}
export function wss_send_$x_(sid, data) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('wss-send!', 2, arguments.length);
let socket = $calcit.get($calcit.deref(_$s_global_connections), sid);

if ($calcit.some_$q_(socket)) { return socket.send($calcit.format_cirru_edn(data)) } else { return console.warn("socket not found for", sid) }

}
export function wss_serve_$x_(port, options) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('wss-serve!', 2, arguments.length);
(function __fn__(){
( $calcit.not($calcit.string_$q_("first argument is port")) ? (function __fn__(){
let err_AUTO_1 = new Error($calcit.str_spaced("expects 1st argument to be string, got:", "first argument is port"));
 err_AUTO_1.data = null;
 throw err_AUTO_1;
})() : null );

if ($calcit.number_$q_(port)) { return null } else { console.error($calcit.printable("Failed assertion:", $calcit.format_to_lisp(new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("number?"), new $calcit.CalcitSymbol("port")]))));
let err_AUTO_2 = new Error("first argument is port (number? port)");
 err_AUTO_2.data = null;
 throw err_AUTO_2;
 }

})();
let wss = ( $calcit.some_$q_($calcit.get(options, _tag["cert"])) ? new WebSocketServer((function __fn__(){
let ssl_options = $calcit._$n_js_object(_tag["key"], $fs.readFileSync($calcit.get(options, _tag["key"])), _tag["cert"], $fs.readFileSync($calcit.get(options, _tag["cert"])));
let server = $https.createServer(ssl_options, function f_PCT_(req, res) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
res.writeHead(200);
return res.end("WSS Server")
}
);
server.addListener("upgrade", function f_PCT_(req, res, head) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('f%', 3, arguments.length);
return console.log(req.url)
}
);
server.on("error", function f_PCT_(err) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return console.error(err)
}
);
server.listen(port, function f_PCT_() { 
if (arguments.length !== 0) throw _calcit_args_mismatch('f%', 0, arguments.length);
console.log($calcit.printable("server at", port))
}
);
return $calcit._$n_js_object(_tag["server"], server, _tag["path"], "/")

})()) : new WebSocketServer($calcit._$n_js_object(_tag["port"], port)) );
wss.on("connection", function f_PCT_(socket, req) { 
if (arguments.length < 1) throw new Error('too few arguments');
if (arguments.length > 2) throw new Error('too many arguments');
return maintain_socket_$x_(socket, options)
}
);
wss.on("listening", function f_PCT_() { 
if (arguments.length !== 0) throw _calcit_args_mismatch('f%', 0, arguments.length);
let on_listening = $calcit.get(options, _tag["on-listening"]);

if ($calcit.some_$q_(on_listening)) { return on_listening() } else { return  null; }

}
);
return wss.on("error", function f_PCT_(error) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
let on_error = $calcit.get(options, _tag["on-error"]);

if ($calcit.some_$q_(on_error)) { return on_error(error) } else { return console.error(error) }

}
)

}



export var _$s_global_connections = 
($calcit.peekDefatom("ws-edn.server/*global-connections") ?? $calcit.defatom("ws-edn.server/*global-connections", $calcit._$n__$M_()))
;

export var _$s_proxied_data_listener = 
($calcit.peekDefatom("ws-edn.server/*proxied-data-listener") ?? $calcit.defatom("ws-edn.server/*proxied-data-listener", null))
;

